#include <sourcemod>
#include <cstrike>

#define PATH "cfg/sourcemod/gspawnermaps.txt"
//  
new Handle:kv;
new String:namemap[30];
new bool:g_respawn;

public Plugin:myinfo = 
{
	name = "GSpawner",
	author = "bezdarea",
	description = "",
	version = "1.0",
	url = "http://www.gedoo.ru"
}

public OnPluginStart()
{
	kv = CreateKeyValues("maps"); 
    if (!FileToKeyValues(kv, PATH)) 
        PrintToServer("Error load cstrike/cfg/sourcemod/gspawnermaps.txt");
	g_respawn = false;
	RegAdminCmd("sm_mgspawn_add", Command_Add, ADMFLAG_ROOT);
	RegAdminCmd("sm_mgspawn_del", Command_Delete, ADMFLAG_ROOT);
	//RegConsoleCmd("sm_mgspawn_add", Command_Add);
	//RegConsoleCmd("sm_mgspawn_del", Command_Delete);
	HookEvent("player_death", OnPlayerDeath);
}

public OnMapStart()
{
	GetCurrentMap(namemap, sizeof(namemap));	
	if (KvJumpToKey(kv, namemap, false)) 
    { 
		g_respawn = true;
	}
}

public Action:Command_Add(client, argc)
{
	if (KvJumpToKey(kv, namemap, true)) 
    { 
		KvRewind(kv); 
		KeyValuesToFile(kv, PATH); 
		g_respawn = true;
	}
	
}

public Action:Command_Delete(client, argc)
{
	if (KvJumpToKey(kv, namemap, false)) 
    { 
		KvDeleteThis(kv); 
		KvRewind(kv); 
		KeyValuesToFile(kv, PATH); 
		g_respawn = false;
	}
}


public OnPlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (!client || !g_respawn)
	{
		return;
	}
	
	CreateTimer(1.0, respawn, client); 
}

public Action:respawn(Handle:timer, any:client) 
{ 
	CS_RespawnPlayer(client);
} 

